﻿// JScript File
///
/// Georgian To Hatavi Convertor
/// 
/// by Hemn Chawroka 
/// 11/11/2008
/// 

var KurdiMonthNames = new Array ( "خاكه‌لێوه", "بانه‌مه‌ڕ", "جۆزه‌ردان", "پووشپه‌ڕ", "خه‌رمانان", "گه‌لاوێژ", "ره‌زبه‌ر", "گه‌ڵارێزان", "سه‌رماوه‌ز", "به‌فرانبار", "رێبه‌ندان", "ره‌شه‌مێ" );
var KurdiMonthNamesShort = new Array ( "خاک", "بان", "جۆز", "پووش", "خه‌ر", "گه‌ل", "ره‌ز", "گه‌ڵ", "سه‌ر", "به‌فر", "رێ", "ره‌ش" );

var KurdiDayNamesFull = new Array (  "شه‌ممه", "يه‌ک‌شه‌ممه", "دووشه‌ممه", "سێ‌شه‌ممه", "چوارشه‌ممه", "پێنج‌شه‌ممه", "هه‌ینی" );
//var KurdiDayNamesFull = new Array (   "يه‌ک‌شه‌ممه", "دووشه‌ممه", "سێ‌شه‌ممه", "چوارشه‌ممه", "پێنج‌شه‌ممه", "هه‌ینی"  , "شه‌ممه");


function Months_C(Y, M) {
    switch (M) {
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12: return 31;
        case 2: if (Y % 4 == 0) return 29;
            else return 28;
        default: return 30;
    }
}

function DaysInMonth(Year, Month) {
    if (Month == 0) {
        Month = 12;
        Year = Year - 1;
    }
    else if (Month == 13) {
        Month = 1;
        Year = Year + 1;
    }
    else if (Month < 0 || Month>13)
        return -10000;

    if (Month >= 1 && Month <= 6)
        return 31;
    else if (Month == 12) {
        if ((((Year % 4) == 2) && (Year < 1374)) || (((Year % 4) == 3) && (Year >= 1374)))
            return 30;
        else
            return 29;
    }
    else return 30;
}


///
/// HINT: in javascript, January=0, Feb =1, ... 
/// 

function GeorgianToHatavi(dateObject) {
   //alret('sa');
   AYear4=dateObject.getYear();
   if (AYear4 < 1000)
      AYear4+=1900;
   ADay=dateObject.getDate();
   AMonth=dateObject.getMonth()+1; // Check [HINT]
    
    //alert(AYear4 + "/" + AMonth+"/"+ADay);
    Yd = ADay;
    M = AMonth;
    for (i = 1; i < M; i++)
        Yd = Yd + Months_C(AYear4, i);

    AYear4 -= 621;
    Yd -= (DaysInMonth(AYear4 - 1, 12) + DaysInMonth(AYear4 - 1, 11) + 20);

    if (DaysInMonth(AYear4 - 1, 12) == 30)
        Yd++;

    if (Yd > 0) {
        AMonth = 1;
        while (Yd > DaysInMonth(AMonth, AMonth)) {
            Yd -= DaysInMonth(AYear4, AMonth);
            AMonth++;
        }
        ADay = Yd;
    }
    else if (Yd <= 0) {
        AYear4--;
        AMonth = 12;
        while (-Yd >= DaysInMonth(AYear4, AMonth)) {
            Yd += DaysInMonth(AYear4, AMonth);
            AMonth--;
        }
        ADay = DaysInMonth(AYear4, AMonth) + Yd;
    }

    d = dateObject.getDay();
    if (d==6) d=0;
    else d++;


    this.date = ADay;
    this.month = AMonth;
    this.year=AYear4;
    this.day = d;
}


function GeorgianToHataviS(dateStringObject) {
    dateParts = dateStringObject.split('.');
    dateObject = new Date(dateParts[2], dateParts[0]-1,dateParts[1]);
    HataviDate = GeorgianToHatavi(dateObject);
    return ' ' + HataviDate.day + '/' + KurdiMonthNames[HataviDate.month] + '/' + HataviDate.year;
}


function HataviToGeorgian(AYear, AMonth, ADay) {
            Yd = ADay;
            M = AMonth;
            for (M = 1; M < AMonth; M++)
                Yd += DaysInMonth(AYear, M);
            
            if (AYear < 1000) AYear += 1300;
            AYear += 621;
            Yd += Months_C(AYear - 1, 12) + Months_C(AYear - 1, 11) + 18;
            
            if (Yd > 0) {
                AMonth = 1;
                while (Yd > Months_C(AYear, AMonth)) {
                    Yd -= Months_C(AYear, AMonth);
                    if (AMonth < 12) AMonth++;
                    else {
                        AYear++;
                        AMonth = 1;
                    }
                }
                ADay = Yd;
            }
            else if (Yd <= 0) {
                AYear--;
                AMonth = 12;
                while (-Yd >= Months_C(AYear, AMonth)) {
                    Yd += Months_C(AYear, AMonth);
                    AMonth--;
                }
                ADay = Months_C(AYear, AMonth) + Yd;
            }
 
            // Check [HINT]
            return new Date(AYear, AMonth-1, ADay);
}